<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="" xml:lang="">
<head>
  <meta charset="utf-8" />
  <meta name="generator" content="pandoc" />
  <meta name="viewport" content="width=device-width, initial-scale=1.0, user-scalable=yes" />
  <title>fdupes</title>
  <style type="text/css">
      code{white-space: pre-wrap;}
      span.smallcaps{font-variant: small-caps;}
      span.underline{text-decoration: underline;}
      div.column{display: inline-block; vertical-align: top; width: 50%;}
  </style>
</head>
<body>
<h1 id="a-command-line-tool-to-find-and-delete-duplicate-files-in-linux">A Command Line Tool to Find and Delete Duplicate Files in Linux</h1>
<blockquote>
<p>fdupes is a Linux utility for identifying or deleting duplicate files in the given set of directories and sub-directories. It recognize duplicates by comparing MD5 signature of files followed by a byte-to-byte comparison.</p>
</blockquote>
<p>It is a common requirement to find and replace duplicate files for most of the computer users. Finding and removing duplicate files is a tiresome job that demands time and patience. Finding duplicate files can be very easy if your machine is powered by GNU/Linux, thanks to ‘<strong>fdupes</strong>‘ utility.</p>
<p><a href="https://www.tecmint.com/wp-content/uploads/2015/08/find-and-delete-duplicate-files-in-linux.png"><img src="https://www.tecmint.com/wp-content/uploads/2015/08/find-and-delete-duplicate-files-in-linux-620x295.png" alt="Find and Delete Duplicate Files in Linux" /></a></p>
<p>Fdupes – Find and Delete Duplicate Files in Linux</p>
<h4 id="what-is-fdupes">What is fdupes?</h4>
<p><strong>Fdupes</strong> is a Linux utility written by <strong>Adrian Lopez</strong> in <strong>C</strong> programming Language released under MIT License. The application is able to find duplicate files in the given set of directories and sub-directories. Fdupes recognize duplicates by comparing MD5 signature of files followed by a byte-to-byte comparison. A lots of options can be passed with Fdupes to list, delete and replace the files with hardlinks to duplicates.</p>
<p>The comparison starts in the order:</p>
<p><strong>size comparison</strong> &gt; <strong>Partial MD5 Signature Comparison</strong> &gt; <strong>Full MD5 Signature Comparison</strong> &gt; <strong>Byte-to-Byte Comparison</strong>.</p>
<h3 id="install-fdupes-on-a-linux">Install fdupes on a Linux</h3>
<p>Installation of latest version of fdupes (fdupes version 1.51) as easy as running following command on <strong>Debian</strong> based systems such as <strong>Ubuntu</strong> and <strong>Linux Mint</strong>.</p>
<p>$ sudo apt-get install fdupes</p>
<p><a href="https://freestar.com/?utm_medium=ad_container&amp;utm_source=branding&amp;utm_name=tecmint_incontent"><img src="https://a.pub.network/core/imgs/fslogo-green.svg" alt="freestar" /></a></p>
<p>On <strong>CentOS</strong>/<strong>RHEL</strong> and <strong>Fedora</strong> based systems, you need to turn on <a href="https://www.tecmint.com/how-to-enable-epel-repository-for-rhel-centos-6-5/">epel repository</a> to install fdupes package.</p>
<p># yum install fdupes # dnf install fdupes [On Fedora 22 onwards]</p>
<p><strong>Note</strong>: The default package manager <strong>yum</strong> is replaced by <strong>dnf</strong> from <strong>Fedora 22</strong> onwards…</p>
<h3 id="how-to-use-fdupes-command">How to use fdupes command?</h3>
<p><strong>1.</strong> For demonstration purpose, let’s a create few duplicate files under a directory (say <strong>tecmint</strong>) simply as:</p>
<p>$ mkdir /home/“<span class="math inline">$USER"/Desktop/tecmint &amp;&amp; cd /home/"$</span>USER”/Desktop/tecmint &amp;&amp; for i in {1..15}; do echo “I Love Tecmint. Tecmint is a very nice community of Linux Users.” &gt; tecmint${i}.txt ; done</p>
<p>After running above command, let’s verify the duplicates files are created or not using <a href="https://www.tecmint.com/15-basic-ls-command-examples-in-linux/">ls command</a>.</p>
<p><strong>$ ls -l</strong></p>
<p>total 60 -rw-r–r– 1 tecmint tecmint 65 Aug 8 11:22 tecmint10.txt -rw-r–r– 1 tecmint tecmint 65 Aug 8 11:22 tecmint11.txt -rw-r–r– 1 tecmint tecmint 65 Aug 8 11:22 tecmint12.txt -rw-r–r– 1 tecmint tecmint 65 Aug 8 11:22 tecmint13.txt -rw-r–r– 1 tecmint tecmint 65 Aug 8 11:22 tecmint14.txt -rw-r–r– 1 tecmint tecmint 65 Aug 8 11:22 tecmint15.txt -rw-r–r– 1 tecmint tecmint 65 Aug 8 11:22 tecmint1.txt -rw-r–r– 1 tecmint tecmint 65 Aug 8 11:22 tecmint2.txt -rw-r–r– 1 tecmint tecmint 65 Aug 8 11:22 tecmint3.txt -rw-r–r– 1 tecmint tecmint 65 Aug 8 11:22 tecmint4.txt -rw-r–r– 1 tecmint tecmint 65 Aug 8 11:22 tecmint5.txt -rw-r–r– 1 tecmint tecmint 65 Aug 8 11:22 tecmint6.txt -rw-r–r– 1 tecmint tecmint 65 Aug 8 11:22 tecmint7.txt -rw-r–r– 1 tecmint tecmint 65 Aug 8 11:22 tecmint8.txt -rw-r–r– 1 tecmint tecmint 65 Aug 8 11:22 tecmint9.txt</p>
<p>The above script create <strong>15</strong> files namely tecmint1.txt, tecmint2.txt…tecmint15.txt and every files contains the same data i.e.,</p>
<p>“I Love Tecmint. Tecmint is a very nice community of Linux Users.”</p>
<p><strong>2.</strong> Now search for duplicate files within the folder <strong>tecmint</strong>.</p>
<p><strong>$ fdupes /home/$USER/Desktop/tecmint</strong></p>
<p>/home/tecmint/Desktop/tecmint/tecmint13.txt /home/tecmint/Desktop/tecmint/tecmint8.txt /home/tecmint/Desktop/tecmint/tecmint11.txt /home/tecmint/Desktop/tecmint/tecmint3.txt /home/tecmint/Desktop/tecmint/tecmint4.txt /home/tecmint/Desktop/tecmint/tecmint6.txt /home/tecmint/Desktop/tecmint/tecmint7.txt /home/tecmint/Desktop/tecmint/tecmint9.txt /home/tecmint/Desktop/tecmint/tecmint10.txt /home/tecmint/Desktop/tecmint/tecmint2.txt /home/tecmint/Desktop/tecmint/tecmint5.txt /home/tecmint/Desktop/tecmint/tecmint14.txt /home/tecmint/Desktop/tecmint/tecmint1.txt /home/tecmint/Desktop/tecmint/tecmint15.txt /home/tecmint/Desktop/tecmint/tecmint12.txt</p>
<p><strong>3.</strong> Search for duplicates recursively under every directory including it’s sub-directories using the <strong>-r</strong> option.</p>
<p>It search across all the files and folder recursively, depending upon the number of files and folders it will take some time to scan duplicates. In that mean time, you will be presented with the total progress in terminal, something like this.</p>
<p><strong>$ fdupes -r /home</strong></p>
<p>Progress [37780/54747] 69%</p>
<p><strong>4.</strong> See the size of duplicates found within a folder using the <strong>-S</strong> option.</p>
<p><strong>$ fdupes -S /home/$USER/Desktop/tecmint</strong></p>
<p><strong>65 bytes each</strong>:<br />
/home/tecmint/Desktop/tecmint/tecmint13.txt /home/tecmint/Desktop/tecmint/tecmint8.txt /home/tecmint/Desktop/tecmint/tecmint11.txt /home/tecmint/Desktop/tecmint/tecmint3.txt /home/tecmint/Desktop/tecmint/tecmint4.txt /home/tecmint/Desktop/tecmint/tecmint6.txt /home/tecmint/Desktop/tecmint/tecmint7.txt /home/tecmint/Desktop/tecmint/tecmint9.txt /home/tecmint/Desktop/tecmint/tecmint10.txt /home/tecmint/Desktop/tecmint/tecmint2.txt /home/tecmint/Desktop/tecmint/tecmint5.txt /home/tecmint/Desktop/tecmint/tecmint14.txt /home/tecmint/Desktop/tecmint/tecmint1.txt /home/tecmint/Desktop/tecmint/tecmint15.txt /home/tecmint/Desktop/tecmint/tecmint12.txt</p>
<p><strong>5.</strong> You can see the size of duplicate files for every directory and subdirectories encountered within using the <strong>-S</strong> and <strong>-r</strong> options at the same time, as:</p>
<p><strong>$ fdupes -Sr /home/avi/Desktop/</strong></p>
<p><strong>65 bytes each:</strong><br />
/home/tecmint/Desktop/tecmint/tecmint13.txt /home/tecmint/Desktop/tecmint/tecmint8.txt /home/tecmint/Desktop/tecmint/tecmint11.txt /home/tecmint/Desktop/tecmint/tecmint3.txt /home/tecmint/Desktop/tecmint/tecmint4.txt /home/tecmint/Desktop/tecmint/tecmint6.txt /home/tecmint/Desktop/tecmint/tecmint7.txt /home/tecmint/Desktop/tecmint/tecmint9.txt /home/tecmint/Desktop/tecmint/tecmint10.txt /home/tecmint/Desktop/tecmint/tecmint2.txt /home/tecmint/Desktop/tecmint/tecmint5.txt /home/tecmint/Desktop/tecmint/tecmint14.txt /home/tecmint/Desktop/tecmint/tecmint1.txt /home/tecmint/Desktop/tecmint/tecmint15.txt /home/tecmint/Desktop/tecmint/tecmint12.txt</p>
<p><strong>107 bytes each:</strong> /home/tecmint/Desktop/resume_files/r-csc.html /home/tecmint/Desktop/resume_files/fc.html</p>
<p><strong>6.</strong> Other than searching in one folder or all the folders recursively, you may choose to choose in two folders or three folders as required. Not to mention you can use option <strong>-S</strong> and/or <strong>-r</strong> if required.</p>
<p>$ fdupes /home/avi/Desktop/ /home/avi/Templates/</p>
<p><strong>7.</strong> To delete the duplicate files while preserving a copy you can use the option <strong>‘-d’</strong>. Extra care should be taken while using this option else you might end up loosing necessary files/data and mind it the process is unrecoverable.</p>
<p><strong>$ fdupes -d /home/$USER/Desktop/tecmint</strong></p>
<p>[1] /home/tecmint/Desktop/tecmint/tecmint13.txt [2] /home/tecmint/Desktop/tecmint/tecmint8.txt [3] /home/tecmint/Desktop/tecmint/tecmint11.txt [4] /home/tecmint/Desktop/tecmint/tecmint3.txt [5] /home/tecmint/Desktop/tecmint/tecmint4.txt [6] /home/tecmint/Desktop/tecmint/tecmint6.txt [7] /home/tecmint/Desktop/tecmint/tecmint7.txt [8] /home/tecmint/Desktop/tecmint/tecmint9.txt [9] /home/tecmint/Desktop/tecmint/tecmint10.txt [10] /home/tecmint/Desktop/tecmint/tecmint2.txt [11] /home/tecmint/Desktop/tecmint/tecmint5.txt [12] /home/tecmint/Desktop/tecmint/tecmint14.txt [13] /home/tecmint/Desktop/tecmint/tecmint1.txt [14] /home/tecmint/Desktop/tecmint/tecmint15.txt [15] /home/tecmint/Desktop/tecmint/tecmint12.txt</p>
<p>Set 1 of 1, preserve files [1 - 15, all]:</p>
<p>You may notice that all the duplicates are listed and you are prompted to delete, either one by one or certain range or all in one go. You may select a range something like below to delete files files of specific range.</p>
<p>Set 1 of 1, preserve files [1 - 15, all]: <strong>2-15</strong></p>
<p>[-] /home/tecmint/Desktop/tecmint/tecmint13.txt [+] /home/tecmint/Desktop/tecmint/tecmint8.txt [-] /home/tecmint/Desktop/tecmint/tecmint11.txt [-] /home/tecmint/Desktop/tecmint/tecmint3.txt [-] /home/tecmint/Desktop/tecmint/tecmint4.txt [-] /home/tecmint/Desktop/tecmint/tecmint6.txt [-] /home/tecmint/Desktop/tecmint/tecmint7.txt [-] /home/tecmint/Desktop/tecmint/tecmint9.txt [-] /home/tecmint/Desktop/tecmint/tecmint10.txt [-] /home/tecmint/Desktop/tecmint/tecmint2.txt [-] /home/tecmint/Desktop/tecmint/tecmint5.txt [-] /home/tecmint/Desktop/tecmint/tecmint14.txt [-] /home/tecmint/Desktop/tecmint/tecmint1.txt [-] /home/tecmint/Desktop/tecmint/tecmint15.txt [-] /home/tecmint/Desktop/tecmint/tecmint12.txt</p>
<p><strong>8.</strong> From safety point of view, you may like to print the output of <strong>‘fdupes’</strong> to file and then check text file to decide what file to delete. This decrease chances of getting your file deleted accidentally. You may do:</p>
<p>$ fdupes -Sr /home &gt; /home/fdupes.txt</p>
<p><strong>Note</strong>: You may replace <strong>‘/home’</strong> with the your desired folder. Also use option <strong>‘-r’</strong> and <strong>‘-S’</strong> if you want to search recursively and Print Size, respectively.</p>
<p><strong>9.</strong> You may omit the first file from each set of matches by using option <strong>‘-f’</strong>.</p>
<p>First List files of the directory.</p>
<p><strong>$ ls -l /home/$USER/Desktop/tecmint</strong></p>
<p>total 20 -rw-r–r– 1 tecmint tecmint 65 Aug 8 11:22 tecmint9 (3rd copy).txt -rw-r–r– 1 tecmint tecmint 65 Aug 8 11:22 tecmint9 (4th copy).txt -rw-r–r– 1 tecmint tecmint 65 Aug 8 11:22 tecmint9 (another copy).txt -rw-r–r– 1 tecmint tecmint 65 Aug 8 11:22 tecmint9 (copy).txt -rw-r–r– 1 tecmint tecmint 65 Aug 8 11:22 tecmint9.txt</p>
<p>and then omit the first file from each set of matches.</p>
<p><strong>$ fdupes -f /home/$USER/Desktop/tecmint</strong></p>
<p>/home/tecmint/Desktop/tecmint9 (copy).txt /home/tecmint/Desktop/tecmint9 (3rd copy).txt /home/tecmint/Desktop/tecmint9 (another copy).txt /home/tecmint/Desktop/tecmint9 (4th copy).txt</p>
<p><strong>10.</strong> Check installed version of fdupes.</p>
<p><strong>$ fdupes –version</strong></p>
<p>fdupes 1.51</p>
<p><strong>11.</strong> If you need any help on fdupes you may use switch <strong>‘-h’</strong>.</p>
<p><strong>$ fdupes -h</strong></p>
<p>Usage: fdupes [options] DIRECTORY…</p>
<p>-r –recurse for every directory given follow subdirectories encountered within -R –recurse: for each directory given after this option follow subdirectories encountered within (note the ‘:’ at the end of the option, manpage for more details) -s –symlinks follow symlinks -H –hardlinks normally, when two or more files point to the same disk area they are treated as non-duplicates; this option will change this behavior -n –noempty exclude zero-length files from consideration -A –nohidden exclude hidden files from consideration -f –omitfirst omit the first file in each set of matches -1 –sameline list each set of matches on a single line -S –size show size of duplicate files -m –summarize summarize dupe information -q –quiet hide progress indicator -d –delete prompt user for files to preserve and delete all others; important: under particular circumstances, data may be lost when using this option together with -s or –symlinks, or when specifying a particular directory more than once; refer to the fdupes documentation for additional information -N –noprompt together with –delete, preserve the first file in each set of duplicates and delete the rest without prompting the user -v –version display fdupes version -h –help display this help message</p>
<p>That’s for all now. Let me know how you were finding and deleting duplicates files till now in Linux? and also tell me your opinion about this utility. Put your valuable feedback in the comment section below and don’t forget to like/share us and help us get spread.</p>
<p>I am working on another utility called <a href="https://www.tecmint.com/fslint-find-and-remove-duplicate-unwanted-files-in-linux/">fslint to remove duplicate files</a>, will soon post and you people will love to read.</p>
</body>
</html>
